SystemOrganization addCategory: #'CS528-Project'!
SystemOrganization addCategory: #'CS528-Project-Seaside'!
SystemOrganization addCategory: #'CS528-Project-Websocket'!

WAComponent subclass: #ActionButton
	instanceVariableNames: 'callback text class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Seaside'!

!ActionButton commentStamp: '<historical>' prior: 0!
An ActionButton is xxxxxxxxx.

Instance Variables
	callback:		<Object>
	text:		<Object>

callback
	- xxxxx

text
	- xxxxx
!

!ActionButton class methodsFor: 'initialize-release' stamp: 'BrianDentino 7/18/2013 03:43'!
with: aString onClick: aCallback 
	^ self new text: aString; onClick: aCallback.! !

!ActionButton class methodsFor: 'initialize-release' stamp: 'BrianDentino 7/21/2013 20:21'!
with: aString onClick: aCallback class: aClass
	^ self new text: aString; onClick: aCallback; class: aClass.! !

!ActionButton methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 19:54'!
class: aString 
	class := aString.! !

!ActionButton methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/18/2013 03:41'!
onClick: aCallback
	callback := aCallback.! !

!ActionButton methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/21/2013 22:02'!
renderContentOn: html
	| id |
	
	id := html nextId.
	html submitButton 
		id: id;
		class: class;
		class: 'control';
		onClick: ( html jQuery ajax
			callback: [ callback value ] );
		onClick: ( (html jQuery: '.control') hide);
		with: text;
		script: html jQuery this hide.! !

!ActionButton methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/18/2013 03:51'!
text: aString 
	text := aString.! !

WAComponent subclass: #BetSlider
	instanceVariableNames: 'min max step betAmount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Seaside'!

!BetSlider commentStamp: '<historical>' prior: 0!
A BetSlider is a renderable component that presents a slider and label indicating the current value of the slider.

Instance Variables
	betAmount:		<Number> current bet
	max:		<Number> max slider value
	min:		<Number> min slider value
	step:		<Number> slider increment interval

betAmount
	- xxxxx

max
	- xxxxx

min
	- xxxxx

step
	- xxxxx
!

!BetSlider class methodsFor: 'initialize' stamp: 'BrianDentino 7/15/2013 23:08'!
min: minValue max: maxValue step: stepValue
	^ (self new) min: minValue; max: maxValue; step: stepValue.! !

!BetSlider methodsFor: 'accessing' stamp: 'BrianDentino 7/15/2013 22:34'!
betAmount
	^betAmount.! !

!BetSlider methodsFor: 'accessing' stamp: 'BrianDentino 7/21/2013 22:15'!
betAmount: anAmount
	betAmount := anAmount.! !

!BetSlider methodsFor: 'initialize' stamp: 'BrianDentino 7/15/2013 23:12'!
initialize
	super initialize. 
	min := 0.
	max := 0.
	step := 0.
	betAmount := 0.! !

!BetSlider methodsFor: 'accessing' stamp: 'BrianDentino 7/15/2013 23:09'!
max: aValue
	max := aValue! !

!BetSlider methodsFor: 'accessing' stamp: 'BrianDentino 7/16/2013 02:54'!
min: aValue
	min := aValue.
	betAmount := min! !

!BetSlider methodsFor: 'rendering' stamp: 'lb 7/23/2013 21:19'!
renderContentOn: html
	| labelID sliderID |
	
	labelID := html nextId.
	sliderID := html nextId.
	
	html div 
		class: 'bet';
		class: 'raise';
		class: 'control';
		id: sliderID;
		script: (html jQuery new slider
			min: min;
			max: max;
			step: step;
			value: betAmount;
			orientation: #horizontal;
			onSlide: [ :value | ( html jQuery script: [ :s | s << (s jQuery id: labelID) text: value ] ) ];
			onChange: [ :value | ( html jQuery ajax 
				callback: [ :amount | self betAmount: amount asNumber ] value: (value) ) ]
		);
		script: (html jQuery this hide).
		
	html space.
	html space.
	html div id: labelID;
		class: 'bet';
		class: 'raise';
		class: 'control';
		with: betAmount;
		script: (html jQuery this hide).! !

!BetSlider methodsFor: 'accessing' stamp: 'BrianDentino 7/15/2013 23:09'!
step: aValue
	step := aValue! !

WAComponent subclass: #PokerPlayerView
	instanceVariableNames: 'playerID tableID table browser playerList community hand lastPlayerAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Seaside'!

PokerPlayerView class
	instanceVariableNames: 'nextID'!

!PokerPlayerView commentStamp: '<historical>' prior: 0!
A PokerPlayer is a Seaside component that manages client decisions. When the state of a game changes, the PokerPlayer class notifies the view via a websocket connection to the browser.

Instance Variables
!

PokerPlayerView class
	instanceVariableNames: 'nextID'!

!PokerPlayerView class methodsFor: 'initialize' stamp: 'BrianDentino 7/12/2013 02:13'!
initialize 
	super initialize.
	nextID := 0.! !

!PokerPlayerView class methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 16:17'!
nextID
	nextID := nextID + 1.
	^ nextID asString.! !

!PokerPlayerView class methodsFor: 'initialize' stamp: 'lb 6/13/2013 19:18'!
tableID: table
	^(self new tableID: table playerID: PokerPlayerView nextID)! !

!PokerPlayerView methodsFor: 'actions' stamp: 'BrianDentino 7/21/2013 18:59'!
allIn 

	| action |
	
	action := Dictionary new.
	action at: 'actionType' put: 'allIn'.
	
	self sendPlayerAction: action! !

!PokerPlayerView methodsFor: 'actions' stamp: 'BrianDentino 7/21/2013 18:57'!
bet: anAmount 

	| action |

	action := Dictionary new.
	action at: 'actionType' put: 'bet'.
	action at: 'amount' put: anAmount.
	
	self sendPlayerAction: action! !

!PokerPlayerView methodsFor: 'actions' stamp: 'BrianDentino 7/24/2013 00:36'!
buyIn: anAmount

	| action |

	action := Dictionary new.
	action at: 'actionType' put: 'buyIn'.
	action at: 'amount' put: anAmount.
	action at: 'playerID' put: playerID.
	
	table sendMessage: (WebsocketMessage id: #asyncAction content: action) json.! !

!PokerPlayerView methodsFor: 'actions' stamp: 'BrianDentino 7/21/2013 18:57'!
call

	| action |
	
	action := Dictionary new.
	action at: 'actionType' put: 'call'.
	
	self sendPlayerAction: action! !

!PokerPlayerView methodsFor: 'websockets' stamp: 'BrianDentino 7/12/2013 01:47'!
close
	table close.! !

!PokerPlayerView methodsFor: 'actions' stamp: 'lb 7/19/2013 22:38'!
fold 

	| action |
	
	action := Dictionary new.
	action at: 'actionType' put: 'fold'.
	
	self sendPlayerAction: action! !

!PokerPlayerView methodsFor: 'initialize-release' stamp: 'lb 7/22/2013 20:28'!
initialize 
	super initialize.
	browser := BrowserWebsocket delegate: self.
	playerList := Players new.
	community := Hand new.
	hand := Hand new.
	lastPlayerAction := PokerPlayerAction new.! !

!PokerPlayerView methodsFor: 'websockets' stamp: 'BrianDentino 7/21/2013 21:27'!
onMessage: aMessage from: websocket

	(websocket == table) ifTrue: [ browser sendMessage: aMessage ].
	(websocket == browser) ifTrue: [ table sendMessage: aMessage ].! !

!PokerPlayerView methodsFor: 'accessing' stamp: 'lb 7/13/2013 15:16'!
playerID
	^ playerID! !

!PokerPlayerView methodsFor: 'actions' stamp: 'BrianDentino 7/21/2013 18:57'!
raise: anAmount 

	| action |

	action := Dictionary new.
	action at: 'actionType' put: 'raise'.
	action at: 'amount' put: anAmount.
	
	self sendPlayerAction: action! !

!PokerPlayerView methodsFor: 'rendering' stamp: 'lb 7/24/2013 18:43'!
renderContentOn: html

	html text: 'Welcome to table ', tableID, '. You are player ', playerID, '.'.
	html horizontalRule.
	
	html div id: 'winner'; class: 'winner'.
	
	html text: 'The pot:'.
	html div id: 'pot'.
	html horizontalRule.
			
	html div id: 'hand';
		with: [ 
			html render: hand 
	].
	html horizontalRule.
		
	html div id: 'players';
		with: [ 
			html render: playerList.
	].
	
	html div id: 'community';
		with: [ 
			html render: community.
	].
	
	self renderControlsOn: html.
	
	html render: (WebsocketHandlerComponent wsAddress: 'ws://localhost:1701/', tableID, '_', playerID).
	
	 self renderJSPlayersUpdateOn: html.! !

!PokerPlayerView methodsFor: 'rendering' stamp: 'lb 7/24/2013 21:05'!
renderControlsOn: html 
	| betSlider |

	betSlider := BetSlider min: 5 max: 100 step: 5.
	
	html render: betSlider.
	
	html render: (ActionButton 
		with: 'Bet' 
		onClick: [ self bet: betSlider betAmount. ]
		class: 'bet').
	html render: (ActionButton 
		with: 'Call' 
		onClick: [ self call. ]
		class: 'call').
	html render: (ActionButton 
		with: 'Check' 
		onClick: [ self call. ]
		class: 'check').
	html render: (ActionButton 
		with: 'Fold' 
		onClick: [ self fold. ]
		class: 'fold').
	html render: (ActionButton 
		with: 'Raise' 
		onClick: [ self raise: betSlider betAmount. ] 
		class: 'raise').
	html render: (ActionButton 
		with: 'All In' 
		onClick: [ self allIn. ]
		class: 'allIn').
	html render: (ActionButton 
		with: 'Buy In'
		onClick: [ self buyIn: 500. ]
		class: 'buyIn').
		
	html div id: 'call';
		class: 'call';
		class: 'control';
		with: [ 
			html span: 'To call:'.
			html div id: 'toCall'. 
		];
		script: (html jQuery this hide).! !

!PokerPlayerView methodsFor: 'rendering' stamp: 'BrianDentino 7/24/2013 05:30'!
renderJSPlayersUpdateOn: html
	html script: 
	'
	updatePlayers = function() { 
		// identify my player
		var myPlayer = $("#', playerID, '");
		myPlayer.addClass("myPlayer");
		
		// add hand to myPlayer''s widget
		if ($("#myCards").length == 0) { 
			console.log("no cards");
			myPlayer.append("<div id=''myCards''></div>")
			console.log($("#myCards").length);
		}
		$("#myCards").html($("#hand").html());
		console.log("my hand");
		console.log($("#hand").html());
		console.log("my cards");
		console.log($("#myCards").html());

		// position players
		var angle = Math.PI / 2;
		var elems = document.getElementsByClassName("pokerPlayer");
		var increase = Math.PI * 2 / elems.length;
		
		var playersBefore = myPlayer.prevAll();
		for (var i = 0; i < playersBefore.length; i++) {
    			angle -= increase;
		}

		var x = 0,
   	 		y = 0,
    			elem;
		for (var i = 0; i < elems.length; i++) {
    			elem = elems[i];
    			x = ($("#players").width() / 2 - 30) * Math.cos(angle) + ($("#players").width() / 2 - 70);
    			y = ($("#players").height() / 2) * Math.sin(angle) + ($("#players").height() / 2 - 30);
    			elem.style.position = "absolute";
    			elem.style.left = x + "px";
    			elem.style.top = y + "px";
    			angle += increase;
		}
	}
	'.! !

!PokerPlayerView methodsFor: 'websockets' stamp: 'lb 7/21/2013 15:46'!
sendPlayerAction: anAction

	table sendMessage: (WebsocketMessage id: #playerAction content: anAction) json.! !

!PokerPlayerView methodsFor: 'rendering' stamp: 'EricSteele 7/25/2013 23:31'!
style
	^ '
div {
    font-family: monospace;
    text-align: center;
}
#hand { 
	visibility: hidden;
	position: absolute;
}
#community {
    width: 390px;
    height: 110px;
    margin: 0 auto;
    position: relative;
    top: -255px;
}
.card {
    width: 65px;
    height: 90px;
    border: 1px solid #000000;
    border-radius: 6px;
    position: relative;
    float: left;
    box-shadow: 0px 3px 3px #444444;
    background-image: linear-gradient(bottom, rgba(204, 203, 178, 1) 8%, rgba(240, 239, 226, 1) 37%);
    background-image: -o-linear-gradient(bottom, rgba(204, 203, 178, 1) 8%, rgba(240, 239, 226, 1) 37%);
    background-image: -moz-linear-gradient(bottom, rgba(204, 203, 178, 1) 8%, rgba(240, 239, 226, 1) 37%);
    background-image: -webkit-linear-gradient(bottom, rgba(204, 203, 178, 1) 8%, rgba(240, 239, 226, 1) 37%);
    background-image: -ms-linear-gradient(bottom, rgba(204, 203, 178, 1) 8%, rgba(240, 239, 226, 1) 37%);
    background-image: -webkit-gradient(linear, left bottom, left top, color-stop(0.08, rgba(204, 203, 178, 1)), color-stop(0.37, rgba(240, 239, 226, 1)));
}
#community .card {
    margin: 5px;
}
#myCards {
    width: 130px;
    height: 110px;
    position: absolute;
    top: -50px;
    left: 50%;
    margin: 0px -50px;
    z-index: -1;
}
#myCards .card {
    margin: -2px;
}
.red {
    color: #8B0000;
}
.card .rank {
    width: 20px;
    font-size: 35px;
    margin: 5px 0px 0px 5px;
    line-height: 30px;
    float: left;
}
.card .suit {
    font-size: 28px;
    width: 30px;
    line-height: 30px;
    float: left;
    margin: 7px 0px;
}
#players {
    width: auto;
    height: 400px;
    margin-top: 100px;
    margin-left: 45px;
    margin-right: 45px;
    position: relative;
    background-color: #AFD4B7;
    border-radius: 50%;
    background-position: 20px 50px;
}
.pokerPlayer {
    width: 120px;
    position: relative;
    z-index: 0;
}
.inHand:before, .inHand:after {
    width: 65px;
    height: 50px;
    background-color: #000;
    border: 2px solid #ddd;
    border-radius: 6px;
    position: absolute;
    content:"";
    top: -30px;
    left: 5px;
    z-index: -1;
    background-color:#2e4a66;
    background-size:16px 16px;
    box-shadow: 0px 0px 2px 1px #000;
}
.inHand:after {
    top: -30px;
    left: 70px;
}
.inHand.myPlayer:after, 
.inHand.myPlayer:before {
    visibility: hidden;
}
.playerWidget {
    border: 2px solid #064c0e;
    border-radius: 10px;
    -webkit-border-radius: 10px;
    -moz-border-radius: 10px;
    width: 100%;
    padding: 5px 10px;
    background-image: -webkit-gradient(linear, 0 100%, 0 0, color-stop(0.18, rgb(52, 82, 60)), color-stop(0.74, rgb(104, 158, 122)));
    background-image: -webkit-linear-gradient(bottom, rgb(52, 82, 60) 18%, rgb(104, 158, 122) 74%);
    background-image: -moz-linear-gradient(bottom, rgb(52, 82, 60) 18%, rgb(104, 158, 122) 74%);
    background-image: -o-linear-gradient(bottom, rgb(52, 82, 60) 18%, rgb(104, 158, 122) 74%);
    background-image: -ms-linear-gradient(bottom, rgb(52, 82, 60) 18%, rgb(104, 158, 122) 74%);
    background-image: linear-gradient(bottom, rgb(52, 82, 60) 18%, rgb(104, 158, 122) 74%);
    z-index: 1;
    box-shadow: 0px 3px 6px #444444;
}
.playerName {
    color : white;
    font-family: monospace;
    font-size: 14px;
    padding: 5px 0px 5px;
    position: relative;
    width: 100%;
    text-align: center;
}
.playerMoney {
    color : #FFE4B5;
    font-family: monospace;
    font-size: 18px;
    padding: 0px 0px 5px;
    position: relative;
    width: 96%;
    text-align: center;
}
.playerAction {
    width: 100%;
    padding: 22px 10px 5px 10px;
    border-radius: 10px;
    border: 2px solid #979681;
    margin: -20px auto;
    z-index: -1;
    opacity: 0.9;
    position: absolute;
    background-image: linear-gradient(bottom, rgba(204, 203, 178, 0.85) 8%, rgba(240, 239, 226, 0.85) 37%);
    background-image: -o-linear-gradient(bottom, rgba(204, 203, 178, 0.85) 8%, rgba(240, 239, 226, 0.85) 37%);
    background-image: -moz-linear-gradient(bottom, rgba(204, 203, 178, 0.85) 8%, rgba(240, 239, 226, 0.85) 37%);
    background-image: -webkit-linear-gradient(bottom, rgba(204, 203, 178, 0.85) 8%, rgba(240, 239, 226, 0.85) 37%);
    background-image: -ms-linear-gradient(bottom, rgba(204, 203, 178, 0.85) 8%, rgba(240, 239, 226, 0.85) 37%);
    background-image: -webkit-gradient(linear, left bottom, left top, color-stop(0.08, rgba(204, 203, 178, 0.85)), color-stop(0.37, rgba(240, 239, 226, 0.85)));
}
.playerWidget .button {
    font-size: 24px;
    position: absolute;
    width: 30px;
    height: 30px;
    top: -8px;
    left: -8px;
    border: 2px solid #584C00;
    border-radius: 30x;
    -webkit-border-radius: 30px;
    -moz-border-radius: 30px;
    background-image: linear-gradient(bottom, rgb(102, 98, 32) 18%, rgb(201, 201, 105) 74%);
    background-image: -o-linear-gradient(bottom, rgb(102, 98, 32) 18%, rgb(201, 201, 105) 74%);
    background-image: -moz-linear-gradient(bottom, rgb(102, 98, 32) 18%, rgb(201, 201, 105) 74%);
    background-image: -webkit-linear-gradient(bottom, rgb(102, 98, 32) 18%, rgb(201, 201, 105) 74%);
    background-image: -ms-linear-gradient(bottom, rgb(102, 98, 32) 18%, rgb(201, 201, 105) 74%);
    background-image: -webkit-gradient(linear, left bottom, left top, color-stop(0.18, rgb(102, 98, 32)), color-stop(0.74, rgb(201, 201, 105)));
}
.myPlayer .playerWidget {
    border: 2px solid #063054;
    background-image: -webkit-gradient(linear, 0 100%, 0 0, color-stop(0.18, rgb(16, 72, 94)), color-stop(0.74, rgb(81, 129, 166)));
    background-image: -webkit-linear-gradient(bottom, rgb(16, 72, 94) 18%, rgb(81, 129, 166) 74%);
    background-image: -moz-linear-gradient(bottom, rgb(16, 72, 94) 18%, rgb(81, 129, 166) 74%);
    background-image: -o-linear-gradient(bottom, rgb(16, 72, 94) 18%, rgb(81, 129, 166) 74%);
    background-image: linear-gradient(bottom, rgb(16, 72, 94) 18%, rgb(81, 129, 166) 74%);
}
.currentPlayer .playerWidget {
    border: 2px solid #400000;
    background-image: linear-gradient(bottom, rgb(82, 52, 72) 18%, rgb(156, 103, 135) 74%);
    background-image: -o-linear-gradient(bottom, rgb(82, 52, 72) 18%, rgb(156, 103, 135) 74%);
    background-image: -moz-linear-gradient(bottom, rgb(82, 52, 72) 18%, rgb(156, 103, 135) 74%);
    background-image: -webkit-linear-gradient(bottom, rgb(82, 52, 72) 18%, rgb(156, 103, 135) 74%);
    background-image: -ms-linear-gradient(bottom, rgb(82, 52, 72) 18%, rgb(156, 103, 135) 74%);
    background-image: -webkit-gradient(linear, left bottom, left top, color-stop(0.18, rgb(82, 52, 72)), color-stop(0.74, rgb(156, 103, 135)));
}
.inactivePlayer .playerWidget {
    border: 2px solid #777777;
    background-image: -webkit-gradient(linear, 0 100%, 0 0, color-stop(0.18, rgba(82, 82, 82, 1)), color-stop(0.74, rgba(148, 148, 148, 1)));
    background-image: -webkit-linear-gradient(bottom, rgba(82, 82, 82, 1) 18%, rgba(148, 148, 148, 1) 74%);
    background-image: -moz-linear-gradient(bottom, rgba(82, 82, 82, 1) 18%, rgba(148, 148, 148, 1) 74%);
    background-image: -o-linear-gradient(bottom, rgba(82, 82, 82, 1) 18%, rgba(148, 148, 148, 1) 74%);
    background-image: -ms-linear-gradient(bottom, rgba(82, 82, 82, 1) 18%, rgba(148, 148, 148, 1) 74%);
    background-image: linear-gradient(bottom, rgba(82, 82, 82, 1) 18%, rgba(148, 148, 148, 1) 74%);
    opacity: 0.9;
}
.inactivePlayer .card {
    visibility: hidden;
}
.inactivePlayer .playerWidget .playerName {
    color: #333333;
}
.inactivePlayer .playerWidget .playerMoney {
    color: #AAAAAA;
}
.inactivePlayer .playerWidget .button {
    border: 2px solid #444444;
    background-image: -webkit-gradient(linear, 0 100%, 0 0, color-stop(0.18, rgba(30, 30, 30, 1)), color-stop(0.74, rgba(80, 80, 80, 1)));
    background-image: -webkit-linear-gradient(bottom, rgba(30, 30, 30, 1) 18%, rgba(80, 80, 80, 1) 74%);
    background-image: -moz-linear-gradient(bottom, rgba(30, 30, 30, 1) 18%, rgba(80, 80, 80, 1) 74%);
    background-image: -o-linear-gradient(bottom, rgba(30, 30, 30, 1) 18%, rgba(80, 80, 80, 1) 74%);
    background-image: -ms-linear-gradient(bottom, rgba(30, 30, 30, 1) 18%, rgba(80, 80, 80, 1) 74%);
    background-image: linear-gradient(bottom, rgba(30, 30, 30, 1) 18%, rgba(80, 80, 80, 1) 74%);
    color: #777777
}
.inactivePlayer .playerAction {
    visibility: hidden;
}
.sidepot {
    display: inline-block;
    border: solid;
    text-align: center;
    padding: 10px
}
'.! !

!PokerPlayerView methodsFor: 'accessing' stamp: 'BrianDentino 7/6/2013 21:29'!
tableID
	^tableID! !

!PokerPlayerView methodsFor: 'accessing' stamp: 'BrianDentino 7/18/2013 01:38'!
tableID:  aTableID playerID: aPlayerID
	| url |
	tableID := aTableID.
	playerID := aPlayerID.
	url := tableID, '_', playerID.
	table := TableWebsocket tableID: tableID delegate: self.
	
	ZnServer default delegate map: url to: (ZnWebSocketDelegate map: url to: browser).! !

WAComponent subclass: #ProjectLanding
	instanceVariableNames: ''
	classVariableNames: 'tables'
	poolDictionaries: ''
	category: 'CS528-Project-Seaside'!

ProjectLanding class
	instanceVariableNames: 'tables nextTableID'!

!ProjectLanding commentStamp: '<historical>' prior: 0!
A ProjectLanding is a Seaside component that renders a page which allows users to create or join tables for hosting/playing poker games.

Instance Variables
	tables:		<Object>

tables
	- a dictionary of all active tables. key (tableID) maps to PokerTable object.
!

ProjectLanding class
	instanceVariableNames: 'tables nextTableID'!

!ProjectLanding class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/5/2013 22:42'!
canBeRoot
	^ true! !

!ProjectLanding class methodsFor: 'testing' stamp: 'EricSteele 7/23/2013 21:53'!
createTable
	| id |

	"get id for new table and increment"
	id := nextTableID asString.
	nextTableID := nextTableID + 1.
	
	"create and join new table"
	(self tables) at: id put: (TexasHoldEm id: id UI: 'seaside').

	"return the table id string"
	^id.! !

!ProjectLanding class methodsFor: 'testing' stamp: 'EricSteele 7/23/2013 20:36'!
initialize 
	"ProjectLanding initialize"
	
	(WAAdmin register: self asApplicationAt: 'landing')
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQCupertinoTheme.
		
	tables := Dictionary new.
	
	nextTableID := 1.! !

!ProjectLanding class methodsFor: 'testing' stamp: 'BrianDentino 7/12/2013 01:00'!
tables
	^tables.! !

!ProjectLanding methodsFor: 'setup' stamp: 'EricSteele 7/23/2013 20:38'!
createNewTable
	| id |	
	"create and join new table"
	id := ProjectLanding createTable.
	self joinTable: id.! !

!ProjectLanding methodsFor: 'initialization' stamp: 'EricSteele 7/23/2013 20:35'!
initialize 
	super initialize.! !

!ProjectLanding methodsFor: 'setup' stamp: 'EricSteele 7/23/2013 21:50'!
joinExistingTable
	| id prompt done |
	
	prompt := 'Enter a Table ID:'.
	done := false.
	
	[ done ] whileFalse: [ 
		id := self request: prompt.
		ProjectLanding tables at: id 
			ifPresent: [ :value |
				done := true.
				self joinTable: id.
			]
			ifAbsent: [ 
				prompt := 'Table does not exist. Enter a different Table ID:'.
			].
	].

	! !

!ProjectLanding methodsFor: 'setup' stamp: 'BrianDentino 7/15/2013 23:20'!
joinTable: tableID
	self call: (PokerPlayerView tableID: tableID).
	! !

!ProjectLanding methodsFor: 'rendering' stamp: 'EricSteele 7/23/2013 21:23'!
renderContentOn: html

	html heading: 'Welcome to Smalltalk Casino!!'.
	html anchor
		callback: [ self createNewTable. ];
		with: 'Start a table'.
	html space.
	html anchor
		callback: [ self joinExistingTable ];
		with: 'Join a table'.! !

!ProjectLanding methodsFor: 'setup' stamp: 'BrianDentino 7/6/2013 02:09'!
requestTableID
	| id |
	id := self request: 'Enter a Table ID:'.
	^id! !

!ProjectLanding methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/5/2013 22:46'!
states
	^ Array with: self.! !

WAComponent subclass: #WebsocketHandlerComponent
	instanceVariableNames: 'wsAddress id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Seaside'!

!WebsocketHandlerComponent commentStamp: '<historical>' prior: 0!
A WebsocketHandlerComponent is a simple Seaside component that renders javascript capable of establishing a websocket connection between the rendering browser and a websocket server at the address held in wsAddress.

Along with connection logic, it renders a simple message handler that the browser will run. This handler expects JSON encoded messages with an 'id' property and a 'content' property. The message handler will replace the content of the DOM element identified by 'id' with the text of the 'content' property.

Instance Variables
	wsAddress:		<string>

wsAddress
	- string representation of the websocket address
	i.e. 'ws://10.0.0.3:8888/client'
!

!WebsocketHandlerComponent class methodsFor: 'initialize' stamp: 'BrianDentino 7/11/2013 19:51'!
wsAddress: address
	^ (self new) wsAddress: address.! !

!WebsocketHandlerComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 20:00'!
id
	^id! !

!WebsocketHandlerComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 20:00'!
initialize
	super initialize.
	id := 'websocket'! !

!WebsocketHandlerComponent methodsFor: 'accessing' stamp: 'lb 7/24/2013 10:50'!
renderContentOn: html

	html script: '	
	var conn = {};
	conn = new WebSocket("', wsAddress, '");
 
	conn.onmessage = function (event) {
		var json = event.data;
		var obj = JSON.parse(json);
		console.log(obj.id);
		if (obj.id == "request") { 
			$(".".concat(obj.content)).show();
		}
		else { 
			var elt = document.getElementById(obj.id);
			elt.innerHTML = obj.content;
			updatePlayers();
		}

    	};
    
    	conn.onclose = function (event) {
		console.log("connection closed")
    	};
	
'! !

!WebsocketHandlerComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/11/2013 19:52'!
wsAddress
	^wsAddress! !

!WebsocketHandlerComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/11/2013 19:52'!
wsAddress: address
	wsAddress := address.! !

Object subclass: #BrowserWebsocket
	instanceVariableNames: 'delegate websocket lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Websocket'!

!BrowserWebsocket commentStamp: '<historical>' prior: 0!
A BrowserWebsocket is an abstraction over the websocket connection between a client PokerPlayer and the browser rendering it.

Instance Variables
	delegate:		<Object>

delegate
	- xxxxx
!

!BrowserWebsocket class methodsFor: 'initialize' stamp: 'BrianDentino 7/11/2013 22:20'!
delegate: aDelegate 
	^(self new delegate: aDelegate).! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/11/2013 22:20'!
delegate: aDelegate
	delegate := aDelegate.! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/12/2013 00:05'!
initialize
	lock := Mutex new.! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'lb 7/12/2013 16:25'!
sendMessage: aMessage
	websocket isNil ifTrue: [ Transcript show: 'browser websocket not ready yet...' ]
		ifFalse: [ websocket sendMessage: aMessage ].! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'lb 7/19/2013 23:50'!
value: aWebsocket 
	websocket := aWebsocket.
	
	lock critical: [ delegate 
		onMessage: ((WebsocketMessage id: #joining content:  (delegate playerID)) json) 
		from: self. ].
		
	[ websocket runWith: [ :message |
		websocket log info: [
			 'PokerPlayer received message from browser: ', message printString. 
		].
		lock critical: [ delegate onMessage: message from: self. ].
	]. ]
	on: ConnectionClosed 
	do: [ 
		websocket log debug: '**Connection close, cleaning up'.
		delegate close.
	].! !

!BrowserWebsocket methodsFor: 'as yet unclassified' stamp: 'lb 7/12/2013 13:42'!
websocket
^ websocket! !

Object subclass: #PokerTable
	instanceVariableNames: 'id lock players game waitingForResponse lastPlayerAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Websocket'!

!PokerTable commentStamp: '<historical>' prior: 0!
A PokerTable is a container for clients playing poker together. Each client is represented by a websocket. When the game state is updated, the table broadcasts updates to each of the clients.

Instance Variables
!

!PokerTable class methodsFor: 'as yet unclassified' stamp: 'lb 7/19/2013 10:12'!
id: anIdentifier game: aGame
	^ PokerTable new id: anIdentifier game: aGame! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/22/2013 19:18'!
addPlayer: aPlayer at: aWebsocket

	players at: aPlayer name put: aWebsocket.! !

!PokerTable methodsFor: 'websocket' stamp: 'lb 7/19/2013 16:27'!
broadcast: aMessage
	"Send message to all connected clients"

	lock critical: [ 
		players keysAndValuesDo: [  :playerID :ws |
			[ ws sendMessage: aMessage ]
				on: NetworkError
				do: [  :exception | 
					ws log debug: [ exception printString, ' NetworkError in broadcast...ignoring' ] ] ] ]! !

!PokerTable methodsFor: 'protocol' stamp: 'lb 6/13/2013 21:50'!
clear
	players keysDo: [ :playerID | players removeKey: playerID.  ] ! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/24/2013 19:34'!
clearWinner

	| msg |

	msg := (WebsocketMessage id: 'winner' content: '') json.
	self broadcast: msg.! !

!PokerTable methodsFor: 'action requests' stamp: 'BrianDentino 7/24/2013 01:54'!
getPlayerAction: aPlayer availableActions: actionList
	| msg |

	actionList do: [  :action | 
		msg := (WebsocketMessage id: 'request' content: action) json.
		(players at: aPlayer name) sendMessage: msg. 
	].! !

!PokerTable methodsFor: 'action requests' stamp: 'lb 7/23/2013 20:35'!
getPlayerAction: aPlayer availableActions: actionList toCall: anAmount
	| msg |

	actionList do: [  :action | 
		msg := (WebsocketMessage id: 'request' content: action) json.
		(players at: aPlayer name) sendMessage: msg. 
	].

	msg := (WebsocketMessage id: 'toCall' content: anAmount) json.
	(players at: aPlayer name) sendMessage: msg. ! !

!PokerTable methodsFor: 'accessing' stamp: 'BrianDentino 7/6/2013 18:50'!
id
	^id! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/19/2013 10:11'!
id: anIdentifier game: aGame
	game := aGame.
	id := anIdentifier.
	ZnServer default delegate map: id to: (ZnWebSocketDelegate map: id to: self).! !

!PokerTable methodsFor: 'initialize-release' stamp: 'lb 7/19/2013 23:22'!
initialize 
	players := Dictionary new.
	lock := Mutex new.
	waitingForResponse := true.! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 6/7/2013 17:17'!
lastPlayerAction
	^ lastPlayerAction! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 6/13/2013 21:48'!
players
	^ players! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/19/2013 15:47'!
refreshCommunity: aCommunity

	| content msg |

	content := WARenderCanvas builder render: aCommunity.	
	msg := (WebsocketMessage id: 'community' content: content) json.
	self broadcast: msg.! !

!PokerTable methodsFor: 'accessing' stamp: 'BrianDentino 7/24/2013 05:00'!
refreshHands: aPlayerList

	| content msg |
	
	aPlayerList do: [ :player |
		content := WARenderCanvas builder render: player hand.	
		msg := (WebsocketMessage id: 'hand' content: content) json.
		(players at: player name) sendMessage: msg.
	].

	! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/19/2013 15:33'!
refreshPlayerList: aPlayerList

	| content msg |

	content := WARenderCanvas builder render: aPlayerList.	
	msg := (WebsocketMessage id: 'players' content: content) json.
	self broadcast: msg.! !

!PokerTable methodsFor: 'accessing' stamp: 'EricSteele 7/25/2013 23:32'!
refreshPot: aGame
		| content msg |
		
		(aGame usingSidepots) ifTrue: [
			content := WARenderCanvas builder render: (Sidepots newWith: (aGame sidepots)).
			msg := (WebsocketMessage id: 'pot' content: content) json.
		] ifFalse: [
			msg := (WebsocketMessage id: 'pot' content: ('$' , (aGame pot asString))) json.
		].
		
		self broadcast: msg.! !

!PokerTable methodsFor: 'protocol' stamp: 'lb 6/13/2013 21:48'!
unregister: clientWebSocket
	lock critical: [ 
		players keysAndValuesDo: [ :playerID :ws | ws = clientWebSocket ifTrue: [ players removeKey: playerID.  ] ]  ] .
	(players size = 0) ifTrue: [ProjectLanding tables removeKey: id]! !

!PokerTable methodsFor: 'protocol' stamp: 'BrianDentino 7/24/2013 03:26'!
value: websocket

	| msg asyncAction |

	[ websocket runWith: [ :message |
		
			websocket log info: [ 'PokerTable received message: ', message printString ].
	
			msg := WebsocketMessage json: message.
			
			msg id = #joining
				ifTrue: [ game addPlayer: msg content at: websocket ]
				ifFalse: [ 
					msg id = #asyncAction
						ifTrue: [ 
							asyncAction := THPlayerActionFactory new create: (msg content).
							asyncAction executeWith: game.
						] 
						ifFalse: [  
							lastPlayerAction := THPlayerActionFactory new create: (msg content).
							waitingForResponse := false.
						]
				].
		] 
	]
	on: ConnectionClosed 
	do: [ 
		websocket log debug: '!!!!Connection close, cleaning up'.
		self unregister: websocket ]! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/19/2013 23:43'!
waitingForResponse
	^ waitingForResponse! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/19/2013 23:44'!
waitingForResponse: aBoolean
	waitingForResponse := aBoolean! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/24/2013 19:08'!
winner: aPlayer won: anAmount

	| msg |

	msg := (WebsocketMessage id: 'winner' content: 'WINNER: ', aPlayer name, ' has won ', anAmount) json.
	self broadcast: msg.! !

!PokerTable methodsFor: 'accessing' stamp: 'PeterIngulli 7/25/2013 20:58'!
winners: aPlayerList won: anAmountList

	| msg text |
	text := ''.
	aPlayerList doWithIndex: [ :p :i |
		text size=0 ifFalse: [
			text := text, '<br>'
		].
		text := text, p name, ' has won ', (anAmountList at: i) asString.
	].
	msg := (WebsocketMessage id: 'winner' content: text) json.
	self broadcast: msg.! !

Object subclass: #WebsocketMessage
	instanceVariableNames: 'id content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Websocket'!

!WebsocketMessage commentStamp: '<historical>' prior: 0!
A WebsocketMessage is an object intended to represent a websocket message. It contains an id, so the receiver can identify the type of message, as well as content.

Instance Variables
	content:		<string>
	id:		<string>

content
	- String intended to be interpreted as the content of the message

id
	- String intented to be interpreted as the message identifier.
!

!WebsocketMessage class methodsFor: 'creation' stamp: 'lb 7/13/2013 14:05'!
id: aStringId content: aStringContent 
	^ (self new id: aStringId) content: aStringContent.! !

!WebsocketMessage class methodsFor: 'as yet unclassified' stamp: 'lb 7/13/2013 15:08'!
json: aJsonString

	 |obj |
	
	obj := Json readFrom: (ReadStream on: aJsonString).

	^ WebsocketMessage id: obj id content: obj content! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 19:56'!
content
	^content.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'BrianDentino 7/18/2013 03:23'!
content: aString 
	content := aString.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 19:56'!
id
	^id.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'lb 7/13/2013 14:05'!
id: aString 
	id := aString.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'lb 7/13/2013 15:05'!
json

	^ Json render: self! !

!WebsocketMessage methodsFor: 'as yet unclassified' stamp: 'lb 7/18/2013 00:47'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "id" : '.
	aWriteStream nextPutAll: (Json render: id).
	aWriteStream nextPutAll: ', "content" : '.
	"content isDictionary ifTrue: [ aWriteStream nextPutAll: '{' ]."
	aWriteStream nextPutAll: (Json render: content).
	"content isDictionary ifTrue: [ aWriteStream nextPutAll: '}' ]."
	aWriteStream nextPutAll: ' }'.
	^ aWriteStream contents! !

ZnWebSocket subclass: #TableWebsocket
	instanceVariableNames: 'tableID delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project-Websocket'!

!TableWebsocket commentStamp: '<historical>' prior: 0!
A TableWebsocket is an abstraction over the websocket connection between a PokerPlayer and the PokerTable they are currently a member of. It is a reference maintained by the PokerPlayer so that 

Instance Variables
	delegate:		<PokerPlayer>
	tableID:		<string>

delegate
	- PokerPlayer which will be required to handle incoming messages on this websocket. Must implement onMessage: message.

tableID
	- string representing the ID of the table this websocket is connected to.
!

!TableWebsocket class methodsFor: 'initialize' stamp: 'BrianDentino 7/11/2013 21:45'!
tableID: id delegate: aDelegate 
	^ ((TableWebsocket to: 'ws://localhost:', ZnServer default port asString, '/', id) tableID: id) delegate: aDelegate.! !

!TableWebsocket methodsFor: 'initialize-release' stamp: 'EricSteele 7/24/2013 21:23'!
delegate: aDelegate

	delegate := aDelegate.
	
	[[self runWith: [ :message | delegate onMessage: message from: self].] 
		on: Error 
		do: [ :e | self log debug: 'Oops!! ' , e className , '!!']. 
	] fork.! !

!TableWebsocket methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/11/2013 23:08'!
initialize
	super initialize.
	self role: #server.! !

!TableWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/6/2013 22:24'!
tableID: id
	tableID := id! !
PokerPlayerView initialize!
ProjectLanding initialize!
